"des2sparse"<- function(Terms, data, contrasts)
{
	temp <- is.random(data)
	facmat <- attr(Terms, "factors")[ - attr(Terms, "response"),  , drop = 
		F]
	varnames <- dimnames(facmat)[[1]]
	ranvec <- rep(F, length = length(varnames))
	names(ranvec) <- varnames
	ranvec[names(temp)] <- temp
	termvec <- rep.int(1, length(ranvec)) %*% (facmat * ranvec)
	names(termvec) <- dimnames(termvec)[[2]]
	rows <- dim(data)[1]
	intercept <- attr(Terms, "intercept")
	isfac <- sapply(data[, varnames, drop=F], function(x)	length(levels(x)) > 0)	
#  
#
# create the matrix of fixed effects
	if(any(termvec == 0)) {
		if(intercept) {
			fixedterms <- paste(names(termvec[termvec == 0]), 
				collapse = " + ")
		}
		else fixedterms <- paste(paste(names(termvec[termvec == 0]), 
				collapse = " + "), "-1")
		formula <- attr(Terms, "formula")
		formula <- eval(parse(text = paste(deparse(formula[[2]]), "~", 
			fixedterms)))
		xmat <- model.matrix(formula, data, contrasts)
		attr(xmat, "formula") <- NULL
		attr(xmat, "order") <- NULL
	}
	else if(intercept) {
		formula <- attr(Terms, "formula")
		formula <- eval(parse(text = paste(deparse(formula[[2]]), "~", 
			1)))
		xmat <- model.matrix(formula, data)
		attr(xmat, "formula") <- NULL
		attr(xmat, "order") <- NULL
	}
	else xmat <- NULL
	ranterms <- facmat[, names(termvec[termvec >= 1]), drop = F]
	nrterms <- if(length(ranterms)) ncol(ranterms) else 0
	zmat <- list(numeric(rows * nrterms), numeric(rows * nrterms))
	attributes(zmat) <- list(class = "sparsemat", nrow = rows, names = c(
		"column", "value"))
	if(nrterms) {
		assign.ran <- vector(mode = "list", nrterms)
		names(assign.ran) <- dimnames(ranterms)[[2]]
		ccols <- 0
		for(ti in 1:nrterms) {
			temp <- this.term.sparse(ranterms[, ti], varnames, data,
				rows, T, isfac)
			zmat$column[(1 + (ti - 1) * rows):(ti * rows)] <- temp$
				index + ccols
			zmat$value[(1 + (ti - 1) * rows):(ti * rows)] <- temp$
				value
			assign.ran[[ti]] <- (ccols + 1):(ccols + temp$
				last.index)
			ccols <- ccols + temp$last.index
		}
		attr(zmat, "assign") <- assign.ran
		attr(zmat, "ncol") <- ccols
	}
	list(xmat = xmat, zmat = zmat, intercept = intercept, contrasts = attr(
		xmat, "contrasts"))
}
