"glm.null"<-
function(x, y, w, offset, family)
{
	n <- length(y)
	intl <- attr(x, "term.labels")
	int <- if(is.null(intl)) F else as.logical(match(intl[1], c("(Int.)", 
			"(Intercept)"), F))
	mu <- if(int) weighted.mean(y, w) else family$inverse(0)
	mu <- rep(mu, n)
	deviance <- family$deviance(mu, y, w)
	order <- attr(x, "order")
	if(!any(order) && !(any(offset) & int)) {
		residuals <- family$deriv(mu) * (y - mu)
		eta <- family$link(mu)
		if(int) {
			coefficients <- family$link(mu[1])
			swz <- sqrt(eval(family$weight))
			names(coefficients) <- intl[1]
			R <- matrix( - sqrt(n) * swz[1], dimnames = list(intl[1
				], intl[1]))
			asgn <- 1
			names(asgn) <- "(Intercept)"
			effects <- qr.qty(qr(rep(swz, length = length(residuals
				))), (eta + residuals) * swz)
			names(effects) <- c("(Intercept)", rep("", length(
				residuals) - 1))
		}
		else {
			coefficients <- NULL
			R <- matrix(0)
			asgn <- 0
			effects <- y
		}
		class(R) <- "upper"
		rank <- as.numeric(int)
		attr(R, "rank") <- rank
		wz <- eval(family$weight)
		null.deviance <- deviance
		if(any(offset)) {
			mu <- family$inverse(offset)
			deviance <- family$deviance(mu, y, w)
		}
		list(coefficients = coefficients, residuals = residuals, 
			fitted.values = mu, rank = rank, assign = asgn, effects
			 = effects, df.residual = n - int, weights = wz, y = y, 
			iter = 0, linear.predictors = eta, deviance = deviance, 
			null.deviance = null.deviance, R = R)
	}
	else deviance
}
