"model.matrix.default"<-
function(terms.object, data = list(), contrasts.arg = NULL)
{
        terms.object <- terms(terms.object, data = data)
        if(is.null(attr(data, "terms"))) {
                data <- if(missing(data)) model.frame(terms.object) else
                                model.frame(terms.object, data)
        }
        co.funs <- as.character(.Options$contrasts)
        rowlabs <- attr(data, "row.names")
        nrow <- length(rowlabs)
        if(nrow == 0) {
# in principle, shouldn't happen
                rowlabs <- database.attr("row.names")
                nrow <- length(rowlabs)
                if(nrow == 0) {
                        temp <- data[[1]]
                        if(length(dim(temp)) == 2)
                                nrow <- dim(temp)[1]
                        else nrow <- length(temp)
                        rowlabs <- 1:nrow
                }
        }
        int <- attr(terms.object, "intercept")
        if(!length(terms.object)) {
# null model
                if(!int) zz <- numeric(0) else {
                        zz <- rep(1, nrow)
                        attrs <- list(order = 0)
                        lab <- "(Intercept)"
                        asgn <- list(1)
                        attrs$term.labels <- names(asgn) <- lab
                        attrs$assign <- asgn
                        attributes(zz) <- attrs
                        dim(zz) <- c(nrow, 1)
                        dimnames(zz) <- list(rowlabs, lab)
                }
                class(zz) <- "model.matrix"
                return(zz)
        }
        zz <- .Internal(do.m.m(terms.object, data, co.funs, rowlabs, int,
                contrasts.arg), "do_model_matrix")
        if(!int && dimnames(zz)[[2]][ncol(zz)] == "") {
                dnzz <- dimnames(zz)[[2]]
                ordzz <- attr(zz, "order")[1]
                collabs <- ""
                for(i in seq(ordzz))
                        collabs <- as.vector(outer(collabs, contrasts(zz)[[i]],
                                paste, sep = ""))
                nlabs <- length(collabs)
                nvars <- ncol(zz)
                dimnames(zz)[[2]][1:nlabs] <- collabs
                if(nvars > nlabs)
                        dimnames(zz)[[2]][(nlabs + 1):nvars] <- dnzz[nlabs:(
                                nvars - 1)]
        }
        return(zz)
}
