ts.plot <-
function(...)
{
	dates.plot.space <- function(n, k)
	{
# n is total times in interval
# k is desired number of tick intervals
		if(n <= k + 1) return(rep(T, n))
		j <- (n - (k + 1)) %/% k
		l <- rep(F, n)
		i <- 1
		while(i <= n) {
			l[i] <- T
			i <- i + j + 1
		}
		l
	}
#
###############################################################################
	x <- list(...)
	list.names <- names(x)
	abb <- T
	if(is.null(list.names))
		gargs <- NULL
	else {
# named arguments are assumed to be graphics parameters except abb
		l <- nchar(list.names) > 0
		gargs <- x[l]
		if(any(names(gargs) == "abb")) {
			abb <- gargs$abb
			gargs$abb <- NULL
		}
		x <- x[!l]
	}
	n <- length(x)
	if(!n)
		stop("No data supplied")
	if(is.null(gargs$ylab))
		gargs$ylab <- ""
	nx <- par()$lab[1]
	u.known <- c("days", "weeks", "months", "quarters", "years")	#
###############################################################################
	if(n == 1 && (is.null(dimx <- dim(x[[1]])) || dimx[2] == 1)) {
# treat the case of a single univariate series separately
		x <- x[[1]]
		oldts <- !is.null(attr(x, "tsp"))
		if(!(inherits(x, c("rts", "its", "cts")) || oldts))
			warning("Non time series data")
		if(!is.numeric(x))
			stop("No numeric time series supplied")
		if(is.null(gargs$type))
			gargs$type <- "l"
		u <- if(is.null(temp <- units(x))) "" else temp
		if(is.null(gargs$xlab)) {
			if(l.match <- charmatch(u, u.known, F))
				u <- u.known[l.match]
			if(u != "") {
				gargs$xlab <- paste("Time in", u)
			}
			else {
				gargs$xlab <- "Time"
			}
		}
		if(inherits(start(x), "dates")) {
# calendar time series
			gargs$xaxt <- "n"
			temp <- time(x, origin.julian = c(1, 1, 1970))
			reg <- inherits(x, "cts")
			class(x) <- NULL
			do.call("plot.raw.Internal", c(list(x = temp, y = x), gargs))	#
# put this in front of the previous statement to avoid xlim warnings
			if(!is.null(gargs$xlim)) {
				i <- (as.numeric(temp) >= gargs$xlim[1]) & (as.numeric(temp) <= 
				  gargs$xlim[2])
				if(any(is.na(i)))
				  stop("time domain does not intersect specified limits")
				temp <- temp[i]
			}
			if(!reg) {
				l <- length(temp)
				if(!l.match) {
				  k <- as.numeric(temp[l] - temp[1])
				  if(k > nx * 366)
				    u <- "years"
				  else if(k > nx * 93)
				    u <- "quarters"
				  else if(k > nx * 31)
				    u <- "months"
				  else if(k > nx * 7)
				    u <- "weeks"
				  else u <- "days"
				}
				temp <- seq(from = temp[1], to = temp[l], by = u)
			}
			temp <- temp[dates.plot.space(length(temp), nx)]
			text <- if(!l.match || u == "days" || u == "weeks") temp else {
				y <- years(temp)
				if((u == "months") || u == "quarters") {
				  if(abb) {
				    y <- as.numeric(as.vector(y))
				    if(length(unique(y.div <- y %/% 100)) == 1)
				      y <- y - y.div * 100
				  }
				  paste(as.character(months(temp, abb = abb)), as.character(y)
				    )
				}
				else as.character(y)
			}
			axis(1, at = as.numeric(temp), labels = format(text))
			return(invisible())
		}
		if((inherits(x, "rts") || oldts) && (((freq <- frequency(x)) == 12 && (oldts || 
			u == "months")) || (freq == 4 && (oldts || u == "quarters")))) {
# rts that can be interpreted as calendar
			gargs$xaxt <- "n"
			labs <- if(abb) month.abb else month.name
			if(freq != 12)
				labs <- labs[c(1, 4, 7, 10)]
			temp <- time(x)
			do.call("plot.raw.Internal", c(list(x = temp, y = x), gargs))
			if(!is.null(gargs$xlim)) {
				i <- (temp >= gargs$xlim[1]) & (temp <= gargs$xlim[2])
				if(any(is.na(i)))
				  stop("time domain does not intersect specified limits")
				temp <- temp[i]
			}
			temp <- pretty(temp, nx)
			labs <- labs[round((temp - floor(temp)) * freq) + 1]
			if(abb && length(unique(temp.div <- floor(temp) %/% 100)) == 1)
				labs <- paste(labs, floor(temp) - temp.div * 100)
			else labs <- paste(labs, floor(temp))
			axis(1, at = temp, labels = labs)
			return(invisible())
		}
		temp <- time(x)
		class(x) <- NULL
		do.call("plot.raw.Internal", c(list(x = temp, y = x), gargs))
		return(invisible())
	}
#
###############################################################################
	cal <- reg <- rep(F, n)
	num <- tser <- rep(T, n)
	dfac <- F
	m <- 0
	spcl <- rep(0, n)
	u <- character(n)
	for(i in 1:n) {
		oldts <- !is.null(attr(x[[i]], "tsp"))
		if(!(inherits(x[[i]], c("rts", "its", "cts")) || oldts))
			tser[i] <- F
		if(inherits(x[[i]], "data.frame")) {
			cl <- class(x[[i]])
			cl <- cl[cl != "data.frame"]
			p <- attr(x[[i]], "tspar")
			if(any(fac <- sapply(x[[i]], is.factor)))
				dfac <- T
			if(any(!fac)) {
				x[[i]] <- as.matrix(x[[i]][!fac])
				attr(x[[i]], "tspar") <- p
				class(x[[i]]) <- cl
				m <- m + ncol(x[[i]])
			}
			else num[i] <- F
		}
		else if(inherits(x[[i]], "factor"))
			num[i] <- F
		else m <- m + if(is.null(dimx <- dim(x[[i]]))) 1 else dimx[2]
		if(num[i]) {
			cal[i] <- inherits(start(x[[i]]), "dates")
			reg[i] <- !inherits(x[[i]], "its")
			u[i] <- if(is.null(temp <- units(x[[i]]))) "" else temp
		}
		if(reg[i]) {
			freq <- frequency(x[[i]])
			if(freq == 4 && (oldts || u[i] == "quarters")) {
				if(!cal[i] || (cal[i] && attr(x[[i]], "tspar")$k.units == 1))
				  spcl[i] <- 1
			}
			else if(freq == 12 && (oldts || u[i] == "months")) {
				if(!cal[i] || (cal[i] && attr(x[[i]], "tspar")$k.units == 1))
				  spcl[i] <- -1
			}
		}
		if(!cal[i] && (l <- charmatch(u[i], u.known, F)))
			u[i] <- u.known[l]
	}
	n <- length((1:n)[num])
	if(!n)
		stop("No numeric time series supplied")
	if(any(!num) || dfac)
		warning("Factor data not plotted")
	if(any(!tser))
		warning("Non time series data")
	x <- x[num]	#
###############################################################################
# If any series (but not all) are "cts" plot them as if "rts"
# warning : calendar "its" are not converted
	if(!(all.cal <- all(cal)) && any(cal)) {
		warning("Mixed calendar and non-calendar time series")
		if(any(i <- cal & reg))
			x[i] <- lapply(x[i], as.rts)
	}
	type <- gargs$type
	if(is.null(type))
		type <- rep("l", m)
	else {
		k <- 1:nchar(type)
		type <- rep(substring(type, k, k), len = m)
	}
	pch <- gargs$pch
	if(is.null(pch))
		pch <- rep(0:18, len = m)
	else {
		if(is.character(pch)) {
			k <- 1:nchar(pch)
			pch <- substring(pch, k, k)
		}
		pch <- rep(pch, len = m)
	}
	lty <- rep(if(is.null(gargs$lty)) 1:8 else gargs$lty, len = m)
	col <- rep(if(is.null(gargs$col)) 1:4 else gargs$col, len = m)
	gargs$type <- gargs$pch <- gargs$lty <- gargs$col <- NULL	#
###############################################################################
# check for consistent time units
	u <- unique(u)
	nu <- length(u)
	if(is.null(gargs$xlab)) {
# default x-axis label uses time units if consistent otherwise just "Time"
		if(nu == 1 && u != "") gargs$xlab <- paste("Time in", u) else {
			if(nu > 1)
				warning("Time units may be inconsistent")
			gargs$xlab <- "Time"
		}
	}
#
###############################################################################
# find ranges for both axes 
	times <- lapply(x, time, origin.julian = c(1, 1, 1970))
	xlim <- if(is.null(gargs$xlim)) do.call("range", times) else gargs$xlim
	if(is.null(gargs$ylim))
		ylim <- do.call("range", c(x, na.rm = T))
	else ylim <- gargs$ylim
	if(!all(is.finite(ylim))) ylim <- range(unlist(x)[is.finite(unlist(x))])	#
###############################################################################
	if(all.cal) {
		gargs$xaxt <- "n"
		do.call("plot.raw.Internal", c(list(x = xlim, y = ylim, type = "n"), gargs))
		if(n == 1)
			temp <- times[[1]]
		else {
			k <- xlim[2] - xlim[1]
			if(k > nx * 366)
				v <- "years"
			else if(k > nx * 93)
				v <- "quarters"
			else if(k > nx * 31)
				v <- "months"
			else if(k > nx * 7)
				v <- "weeks"
			else v <- "days"
			temp <- seq(from = xlim[1], to = xlim[2], by = v)
		}
		temp <- temp[dates.plot.space(length(temp), nx)]
		text <- if(nu != 1 || u == "days" || u == "weeks") temp else {
			y <- years(temp)
			if((u == "months") || u == "quarters") {
				if(abb) {
				  y <- as.numeric(as.vector(y))
				  if(length(unique(y.div <- y %/% 100)) == 1)
				    y <- y - y.div * 100
				}
				paste(as.character(months(temp, abb = abb)), as.character(y))
			}
			else as.character(y)
		}
		axis(1, at = as.numeric(temp), labels = format(text))
	}
	else if(sum(spcl) == n) {
# everything can be expressed in "quarters" 
		gargs$xaxt <- "n"
		do.call("plot.raw.Internal", c(list(x = xlim, y = ylim, type = "n"), gargs))
		temp <- seq(from = xlim[1], to = xlim[2], by = 1/4)
		labs <- (if(abb) month.abb else month.name)[c(1, 4, 7, 10)]
		temp <- pretty(temp, nx)
		labs <- labs[round((temp - floor(temp)) * 4) + 1]
		if(abb && length(unique(temp.div <- floor(temp) %/% 100)) == 1)
			labs <- paste(labs, floor(temp) - temp.div * 100)
		else labs <- paste(labs, floor(temp))
		axis(1, at = temp, labels = labs)
	}
	else if(all(spcl)) {
# everything can be expressed in "months"
		gargs$xaxt <- "n"
		do.call("plot.raw.Internal", c(list(x = xlim, y = ylim, type = "n"), gargs))
		temp <- seq(from = xlim[1], to = xlim[2], by = 1/12)
		labs <- if(abb) month.abb else month.name
		temp <- pretty(temp, nx)
		labs <- labs[round((temp - floor(temp)) * 12) + 1]
		if(abb && length(unique(temp.div <- floor(temp) %/% 100)) == 1)
			labs <- paste(labs, floor(temp) - temp.div * 100)
		else labs <- paste(labs, floor(temp))
		axis(1, at = temp, labels = labs)
	}
	else do.call("plot.raw.Internal", c(list(x = xlim, y = ylim, type = "n"), gargs))	#
	k <- 0
	for(i in (1:n)) {
		class(x[[i]]) <- NULL
		dimxi <- dim(x[[i]])
		if(is.null(dimxi)) {
			k <- k + 1
			lines.raw.Internal(times[[i]], x[[i]], type = type[k], lty = lty[k], 
				pch = pch[k], col = col[k])
		}
		else {
			for(j in 1:dimxi[2]) {
# plot each column separately					
				k <- k + 1
				lines.raw.Internal(times[[i]], x[[i]][, j], type = type[k], 
				  lty = lty[k], pch = pch[k], col = col[k])
			}
		}
	}
}
